#!/bin/sh
#
#       License: GPLv2
#       Author: review (http://www.mobileread.com/forums/member.php?u=88891)
#       Author: fortwienix (http://www.mobileread.com/forums/member.php?u=109732)
#
/ebrmain/bin/netagent connect
cd /mnt/ext1
agency=Aachener-Zeitung-$(date +%Y-%m-%d).html

# temp dir where to store all downloaded files
if [ -d myrss-tmp ]; then 
	rm -rf myrss-tmp;
fi
mkdir myrss-tmp;
cd myrss-tmp;

# where is the progressbar app?
if [ -e /mnt/ext1/applications/tools/progressb.app ]; then
  PRG_APP=/mnt/ext1/applications/tools/progressb.app
fi
if [ -e ../progressb.app ]; then
  PRG_APP=../progressb.app
fi

echo '<html><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8"/></head><body>' > $agency
touch feed2
echo "0" > percent

# If you want to add any other feed, add an additional
# line above the feed url below. Each line except the
# last line must end with a backslash before the linebreak character
# Feed urls can be found here: http://www.aachener-zeitung.de/rss
for link in \
http://www.aachener-zeitung.de/cmlink/politik-rss-1.52724 \
http://www.aachener-zeitung.de/cmlink/wirtschaft-rss-1.52726
do
  wget -O feed $link
  cat feed|
  sed 's|<link>|\n<link>|g;s|</link>|</link>\n|g' |grep "<link>"|sed 's|<link>||g;s|</link>||g;' >> feed2
done

if [ ! -z $PRG_APP ]; then
  tail -f percent| $PRG_APP &
fi
total=$(grep -c ^ feed2)
current=0
cat feed2|
while read line; do
        current=$((current+1))
        echo $current $total|awk '{printf "%.0f\n",$1*100/$2}' >> percent

        # there must be at least more than 3 slashed in the URL to be a good feed url
        num=`echo "$line" | grep -o "/" | wc -l`
	if [ $num -lt 4 ]; then
          continue
	fi
        
	rm article-raw
	wget -O article-raw "$line";
	
	# write headline
	cat article-raw | grep '<h1>' | grep -v '<i class' >> $agency

        # line breaks for each div
	cat article-raw | sed 's|<div|\n<div|g;s|</div>|</div>\n|g' > article-raw2

	begin=$(cat article-raw2 |grep -n '<p class="teaser"' |head -1|awk -F: '{print $1}')
	if [ "$begin " = " " ]; then
		continue
	fi
	
	cat article-raw2 | sed -n "${begin},\$p" > article-raw3
	
	end=$(grep -n '<footer' article-raw3 | head -1 | awk -F: '{print $1}')
	if [ "$end " = " " ]; then
		continue
	fi
	
	# print an additional div so that the html is more or less ok when extracting the content
	echo "<div>\n" >> $agency

	# the seds below are just to tidy up the toc of fbreader and remove some unwanted data in the text.
	cat article-raw3 |
	  sed "${end},\$d" |
	  grep -v 'href="#comments"' |
	  grep -v 'doubleclick.net' |
	  sed 's|<h[2-5]>|<br/><b>|g;s|</h[2-5]>|</b><br/>|g' >> $agency
done
echo "100" >> percent
echo '</body></html>' >> $agency
mv $agency ../.
cd ..
rm -rf myrss-tmp
/ebrmain/bin/netagent disconnect
